<template xmlns:input="http://www.w3.org/1999/html">
  <div>
    <div class="padding">
      <div class="row">

        <!--<div class="columns three">-->
          <!--<span v-if="card.type === 1" v-show="true" class="edit" @keydown="inputHandler" @click="startEditName" @blur="setName" :contenteditable="editingName" ref="namefield" >{{card.name || 'Моя карта'}}</span>-->
          <!--<span v-else >{{ card.type === 5 ? 'Наличные' : card.type === 3 ? 'Яндекс.Деньги' : card.name }}</span>-->
        <!--</div>-->
        <div class="columns three card-icon">
          <img :src="`/lk/static/img/my-accounts/${card.img}`" :style="card.activated ? '' : 'filter: grayscale(100%)'" alt="" class="a-image" :class="[card.type === 5 ? 'contact-icons-system' : '']">
        </div>


        <div class="columns three card-text">
          {{ card.type === 5 ? 'Пункт выдачи Contact' : card.description }}
        </div>


        <div v-if="card.activated" class="columns" :class="{
          five: card.main,
          four: !card.main
        }">
          <span v-if="card.main" v-html="msg" class="prima-card"></span>
          <template v-else>
            <a @click="makePrimary" class="prima-card">Сделать основной</a>
            <!--&lt;!&ndash;v-if="card.canBeMain"&ndash;&gt; параметр, позволяющий убрать функцию делать киви кошелек главным-->
          </template>
        </div>
        <div v-else-if="card.type === 3" class="columns four">
          <span class="card-warning">Карта не привязана. <a href="#" @click.prevent="newCard">Привязать</a></span>
        </div>
        <div v-else class="columns four">
          <span class="card-warning">Кошелек не подтвержден. <a href="#" @click.prevent="newCard">Подтвердить</a></span>
        </div>


        <div class="columns one right-adaptive" v-if="!card.main">
          <a v-if="card.deletable" href="#" class="delete a_grey" @click.prevent="showModal(card)"><span>Удалить</span></a>
        </div>


      </div>
      <validate-message v-show="vErrors.has('Номер карты')">
        {{ vErrors.first('Номер карты') }}
      </validate-message>
    </div>
    <hr>
  </div>
</template>

<script>
  import {getPaySystemText} from '@/utils/mappings/accounts'

  export default {
    name: 'card-component',
    props: {
      /** @type ACCOUNT **/
      card: {
        type: Object,
        required: true
      }
    },
    data () {
      return {
        editingName: false
      }
    },
    computed: {
      msg () {
        switch (this.card.type) {
          case 1:
            return 'Займ будет выдан на эту карту';
          case 3:
          case 6:
            return 'Займ будет выдан на этот кошелёк';
          case 5:
            return `Выдача наличными в <a href="https://www.contact-sys.com/where/point/WBRV/0/list/0/0/" target="_blank">пункте выдачи</a>`
        }
        return 'Займ будет выдан на эту карту'
      }
    },
    mounted () {
    	console.log("3162371826317826312368126318723-=-=-=-=-=-", this.card)
      this.$validator.attach({
        name: 'Номер карты',
        rules: 'max:15'
      })
    },
    methods: {
      startEditName () {
        this.editingName = true
        const field = this.$refs.namefield
        setTimeout(() => field.focus(), 0)
      },
      async setName ({target}) {
        const isNameValid = await this.$validator.validate('Номер карты', target.innerHTML)
        if (isNameValid) {
          this.$store.dispatch('ACCOUNTS_SET_NAME', {...this.card.card, name: target.innerHTML})
        } else {
          target.innerHTML = this.card.card.name || 'Моя карта'
        }
      },
      async inputHandler (event) {
        if (event.keyCode === 13) { // По энтеру эмитим блюр, а блюр запустит setName
          event.target.blur(event)
          return
        }
        const allowedCode = [8, 32, 44, 45, 46, 95]
        const isInputValid = await this.$validator.validate('Номер карты', event.target.innerHTML)
        if (!isInputValid && !allowedCode.includes(event.keyCode)) {
          event.preventDefault()
        }
      },
      /**
       * Удаление кошелька
       * @param {ACCOUNT} card
       */
      showModal (card) {
        this.$parent.$modal.show('delete-account', {
          title: card.type === 1 ? 'Удаление карты' : 'Удаление кошелька',
          questionText: `Вы действительно хотите удалить ${card.type === 1 ? 'карту' : 'кошелек'} ${this.card.description}?`,
          action: 'ACCOUNTS_DELETE_ACCOUNT',
          card
        });
      },


      makePrimary () {
        this.$parent.$modal.show('delete-account', {
          title: 'Изменение основного счёта',
          questionText: 'Вы точно хотите изменить основной счёт?',
          action: 'ACCOUNTS_SET_PRIMARY',
          card: this.card
        });
      },
      newCard () {
        this.$parent.$modal.show('new-card')
      }
    }
  }
</script>

<style scoped>
  .blinking {
    animation: blink .3s ease-in-out;
  }

  @keyframes blink {
    0% {
      background-color: #6ac651;
    }
    100% {
      background-color: none;
    }
  }

  .card-warning {
    color: #989898;
    display: inline-block;
    min-height: 20px;
    background: url(/lk/static/img/my-accounts/warning.png) no-repeat 0 50%;
    padding-left: 30px;
    line-height: 20px;
  }

  input[type="text"] {
    border: 0px;
    padding: 0px;
    margin: 0px;
    height: auto;
    width: 100%;
  }

  .contact-icons-system {
    width: 30px;
    height: 30px;
    margin: -10px 0;
  }
</style>
